module.exports = function (React) {
    var Maybe = require('data.maybe');
    var __ref = React;
    var T = __ref.PropTypes;
    var __o = __ref.addons;
    var classSet = __o.classSet;
    return React.createClass({
        propTypes: {
            classNames: T.arrayOf(T.string),
            name: T.string.isRequired,
            label: T.string,
            description: T.string,
            readOnly: T.bool,
            onUpload: T.func.isRequired,
            onError: T.func,
            onChange: T.func
        },
        getDefaultProps: function () {
            return {
                classNames: [],
                label: '',
                description: '',
                readOnly: false,
                currentImage: Maybe.Nothing(),
                addLabel: 'Add',
                addIconClass: 'jsk-icon-add-photo',
                emptyLabel: 'No image',
                emptyIconClass: 'jsk-icon-no-image',
                onChange: function () {
                },
                onError: function (e) {
                    throw e;
                }
            };
        },
        getInitialState: function () {
            return {
                value: this.props.currentImage,
                busy: false
            };
        },
        setValue: function (newValue) {
            if (!this.props.readOnly) {
                var oldValue = this.state.value;
                this.setState({ value: newValue });
                this.props.onChange(newValue, oldValue);
            }
        },
        _onFileChanged: function (ev) {
            var files = this.refs.input.getDOMNode();
            var form = this.refs.form.getDOMNode();
            var self = this;
            this.setState({ busy: true });
            this.props.onUpload(files, form).fork(function (error) {
                self.setState({ busy: false });
                self.onError(error);
            }, function (value) {
                self.setState({ busy: false });
                self.setValue(Maybe.Just(value));
            });
        },
        _onEmptyClicked: function () {
            this.setValue(Maybe.Nothing());
        },
        renderCurrent: function (uri) {
            return React.DOM.li({ className: 'jsk-item jsk-photo-current active' }, React.DOM.img({ src: uri }));
        },
        render: function () {
            var classes = classSet({
                    'jsk-field': true,
                    'jsk-photo-field': true,
                    'jsk-non-editable': this.props.readOnly,
                    'jsk-photo-busy': this.state.busy,
                    'jsk-has-photo': this.state.value.isJust
                }) + ' ' + this.props.classNames.join(' ');
            var noPhotoClass = classSet({
                    'jsk-item': true,
                    'jsk-photo-empty': true,
                    'active': this.state.value.isNothing
                });
            return React.DOM.div({ className: classes }, React.DOM.label({ className: 'jsk-field-label' }, this.props.label), React.DOM.ul({ className: 'unstyled jsk-photo-selection' }, React.DOM.li({ className: 'jsk-item jsk-photo-add' }, React.DOM.div({ className: 'jsk-photo-label' }, this.props.addLabel), React.DOM.div({ className: 'jsk-photo-icon ' + this.props.addIconClass }), React.DOM.form({
                method: 'POST',
                enctype: 'multipart/form-data',
                ref: 'form'
            }, React.DOM.input({
                type: 'file',
                ref: 'input',
                name: this.props.name,
                onChange: this._onFileChanged
            }))), this.state.value.map(this.renderCurrent).getOrElse(null), React.DOM.li({
                className: noPhotoClass,
                onClick: this._onEmptyClicked
            }, React.DOM.div({ className: 'jsk-photo-label' }, this.props.emptyLabel), React.DOM.div({ className: 'jsk-photo-icon ' + this.props.emptyIconClass }))), React.DOM.div({ className: 'jsk-field-description' }, this.props.description));
        }
    });
};