module.exports = function (React) {
    var __ref = require('adt-simple');
    var Base = __ref.Base;
    var Cata = __ref.Cata;
    var __ref$2 = React;
    var T = __ref$2.PropTypes;
    var __o = __ref$2.addons;
    var classSet = __o.classSet;
    var RadioItem = function () {
            function RadioItem$2(label, value) {
                if (!(this instanceof RadioItem$2)) {
                    return new RadioItem$2(label, value);
                }
                if (typeof label === 'string' || Object.prototype.toString.call(label) === '[object String]') {
                    this.label = label;
                } else {
                    throw new TypeError('Unexpected type for field: RadioItem.label');
                }
                if (typeof value === 'string' || Object.prototype.toString.call(value) === '[object String]') {
                    this.value = value;
                } else {
                    throw new TypeError('Unexpected type for field: RadioItem.value');
                }
            }
            var derived = Cata.derive(Base.derive({
                    name: 'RadioItem',
                    constructor: RadioItem$2,
                    prototype: RadioItem$2.prototype,
                    variants: [{
                            name: 'RadioItem',
                            constructor: RadioItem$2,
                            prototype: RadioItem$2.prototype,
                            fields: [
                                'label',
                                'value'
                            ]
                        }]
                }));
            return derived.constructor;
        }();
    return React.createClass({
        statics: { RadioItem: RadioItem },
        propTypes: {
            classNames: T.arrayOf(T.string),
            name: T.string.isRequired,
            items: T.arrayOf(T.instanceOf(RadioItem)).isRequired,
            initialValue: T.string,
            readOnly: T.bool,
            label: T.string,
            description: T.string,
            onChange: T.func
        },
        getDefaultProps: function () {
            return {
                classNames: [],
                initialValue: '',
                readOnly: false,
                label: '',
                description: '',
                onChange: function () {
                }
            };
        },
        getInitialState: function () {
            return { value: this.props.initialValue };
        },
        getValue: function () {
            return this.state.value;
        },
        setValue: function (newValue) {
            var oldValue = this.getValue();
            this.setState({ value: newValue });
            this.props.onChange(newValue, oldValue);
        },
        reset: function () {
            this.setValue(this.props.initialValue);
        },
        _onButtonClicked: function (value) {
            var self = this;
            return function () {
                if (!self.props.readOnly)
                    self.setValue(value);
            };
        },
        renderRadioItem: function (item, i) {
            var classes = classSet({
                    'jsk-radio-item': true,
                    'active': item.value === this.state.value
                });
            return React.DOM.div({
                key: i,
                className: classes,
                onClick: this._onButtonClicked(item.value)
            }, React.DOM.div({ className: 'jsk-radio-item-button' }, React.DOM.div({ className: 'jsk-radio-item-fill' })), React.DOM.div({ className: 'jsk-radio-item-label' }, item.label));
        },
        render: function () {
            var classes = classSet({
                    'jsk-field': true,
                    'jsk-radio-group': true,
                    'jsk-non-editable': this.props.readOnly
                }) + ' ' + this.props.classNames.join(' ');
            return React.DOM.div({ className: classes }, React.DOM.input({
                type: 'hidden',
                name: this.props.name,
                value: this.state.value
            }), React.DOM.label({ className: 'jsk-field-label' }, this.props.label), React.DOM.div({ className: 'jsk-radio-items' }, this.props.items.map(this.renderRadioItem)), React.DOM.div({ className: 'jsk-field-description' }, this.props.description));
        }
    });
};