module.exports = function (React) {
    var Maybe = require('data.maybe');
    var __ref = require('adt-simple');
    var Base = __ref.Base;
    var Cata = __ref.Cata;
    var __ref$2 = React;
    var T = __ref$2.PropTypes;
    var __o = __ref$2.addons;
    var classSet = __o.classSet;
    var Tab = function () {
            function Tab$2(id, label, content) {
                if (!(this instanceof Tab$2)) {
                    return new Tab$2(id, label, content);
                }
                if (typeof id === 'string' || Object.prototype.toString.call(id) === '[object String]') {
                    this.id = id;
                } else {
                    throw new TypeError('Unexpected type for field: Tab.id');
                }
                this.label = label;
                this.content = content;
            }
            var derived = Cata.derive(Base.derive({
                    name: 'Tab',
                    constructor: Tab$2,
                    prototype: Tab$2.prototype,
                    variants: [{
                            name: 'Tab',
                            constructor: Tab$2,
                            prototype: Tab$2.prototype,
                            fields: [
                                'id',
                                'label',
                                'content'
                            ]
                        }]
                }));
            return derived.constructor;
        }();
    function first(xs) {
        return xs.length > 0 ? Maybe.Just(xs[0]) : Maybe.Nothing();
    }
    return React.createClass({
        statics: { Tab: Tab },
        propTypes: {
            classNames: T.arrayOf(T.string),
            tabs: T.arrayOf(T.instanceOf(Tab)).isRequired,
            disabled: T.bool,
            onChange: T.func
        },
        componentDidMount: function () {
            this.setState({ timer: setInterval(this._updateMarkers) });
        },
        componentWillUnmount: function () {
            clearTimeout(this.state.timer);
        },
        getDefaultProps: function () {
            return {
                classNames: [],
                initialTab: Maybe.Nothing(),
                disabled: false,
                onChange: function () {
                }
            };
        },
        getInitialState: function () {
            var self = this;
            return {
                current: self.props.initialTab.orElse(function (a) {
                    return first(self.props.tabs);
                }),
                disabled: self.props.disabled,
                timer: null
            };
        },
        _updateMarkers: function () {
            var self = this;
            var root = this.refs.root.getDOMNode();
            var line = root.querySelector('.jsk-tab-active-line');
            var container = root.querySelector('.jsk-tab-group-container');
            this.state.current.map(function (tab) {
                var button = root.querySelector('.jsk-tab-button.active');
                if (button) {
                    line.style.left = button.offsetLeft + 'px';
                    line.style.width = button.clientWidth + 'px';
                }
                var content = root.querySelector('.jsk-tab-content.active');
                if (content) {
                    container.style.left = -content.offsetLeft + 'px';
                }
            }).orElse(function () {
                line.style.width = '';
                container.style.left = '100%';
            });
        },
        _onTabClicked: function (tab) {
            var self = this;
            return function () {
                self.setState({ current: Maybe.Just(tab) });
            };
        },
        getCurrent: function () {
            return this.state.current;
        },
        isCurrent: function (tab) {
            return this.getCurrent().map(function (a) {
                return a.id === tab.id;
            }).getOrElse(false);
        },
        renderTabContent: function (tab, i) {
            var classes = classSet({
                    'jsk-tab-content': true,
                    active: this.isCurrent(tab)
                });
            return React.DOM.div({
                key: i,
                className: classes
            }, tab.content);
        },
        renderTab: function (tab, i) {
            var classes = classSet({
                    'jsk-tab-button': true,
                    'active': this.isCurrent(tab)
                });
            return React.DOM.div({
                key: i,
                className: classes,
                onClick: this._onTabClicked(tab)
            }, React.DOM.div({ className: 'jsk-tab-label' }, tab.label));
        },
        render: function () {
            var classes = classSet({
                    'jsk-tab-group': true,
                    'jsk-disabled': this.state.disabled,
                    'jsk-has-current-tab': this.getCurrent().isJust
                }) + ' ' + this.props.classNames.join(' ');
            return React.DOM.div({
                className: classes,
                ref: 'root'
            }, React.DOM.div({ className: 'jsk-tab-group-tabs' }, this.props.tabs.map(this.renderTab), React.DOM.div({ className: 'jsk-tab-active-line' })), React.DOM.div({ className: 'jsk-tab-group-content' }, React.DOM.div({ className: 'jsk-tab-group-container' }, this.props.tabs.map(this.renderTabContent))));
        }
    });
};