module.exports = function (React) {
    var __ref = React;
    var T = __ref.PropTypes;
    var __o = __ref.addons;
    var classSet = __o.classSet;
    return React.createClass({
        propTypes: {
            classNames: T.arrayOf(T.string),
            label: T.string,
            name: T.string.isRequired,
            value: T.string.isRequired,
            checked: T.bool,
            description: T.string,
            readOnly: T.bool,
            onChange: T.func
        },
        getDefaultProps: function () {
            return {
                classNames: [],
                label: '',
                checked: false,
                description: '',
                readOnly: false,
                onChange: function () {
                }
            };
        },
        getInitialState: function () {
            return { checked: this.props.checked };
        },
        _onClicked: function () {
            if (!this.props.readOnly) {
                var oldState = this.state.checked;
                this.setState({ checked: !oldState });
                this.props.onChange(!oldState, oldState);
            }
        },
        render: function () {
            var classes = classSet({
                    'jsk-field': true,
                    'jsk-toggle-field': true,
                    'jsk-non-editable': this.props.readOnly,
                    'active': this.state.checked
                }) + ' ' + this.props.classNames.join(' ');
            return React.DOM.div({ className: classes }, React.DOM.div({ className: 'jsk-toggle-container' }, React.DOM.div({ className: 'jsk-label-panel' }, React.DOM.label({
                className: 'jsk-field-label',
                onClick: this._onClicked
            }, this.props.label)), React.DOM.div({ className: 'jsk-toggle-panel' }, React.DOM.input({
                type: 'checkbox',
                checked: this.state.checked,
                ref: 'input',
                value: this.props.value,
                name: this.props.name
            }), React.DOM.div({
                className: 'jsk-toggle-button',
                onClick: this._onClicked
            }, React.DOM.div({ className: 'jsk-toggle-bullet' })))), React.DOM.div({ className: 'jsk-field-description' }, this.props.description));
        }
    });
};